package drakcluster::menu;

use Gtk2;
use strict;
use drakcluster::actions;

our @ISA = qw(Exporter);
our @EXPORT = qw(get_items);

my @items = (
             [ "/_Server", undef, undef, undef, '<Branch>', ],
             [ "/_Server/Configure documentation", undef, \&callback, 3, '<StockItem>', 'gtk-execute', ],
             [ "/_Server/Reset ssh root know_hosts", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/Configure Ganglia", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/Configure Smartmontools", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/Copy current conf in tftp", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/tftp with block size", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/tftp without block size", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/Needed after add | remove node", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/Configure shorewall", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Server/DO all above dangerous)", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Admin", undef, undef, undef, '<Branch>', ],
             [ "/_Admin/configure clusterit", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/set gexec environement", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/set gsh environement", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/set dssh configuration", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/set rshp configuration", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/wulf configuration", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/urpmi configuration", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Admin/DO all above dangerous)", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Compute", undef, undef, undef, '<Branch>', ],
             [ "/_Compute/Adjust node configuration PBS", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/set distcc environement", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/configure Mpi and Lam node configuration", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/set maui configuration reset all config", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/adjust maui node active | desactive", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/DO all above dangerous",, undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_DHCPD", undef, undef, undef, '<Branch>', ],
             [ "/_DHCPD/check tftp server", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DHCPD/backup dhcpd configuration file", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DHCPD/set dhcpd conf", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DHCPD/restart dhcpd", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DHCPD/DO all above (dangerous", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DHCPD/add_nodes", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_NIS", undef, undef, undef, '<Branch>', ],
             [ "/_NIS/configure a NIS server", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_NIS/configure a NIS client", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_NIS/display list of NIS users", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_NIS/rebuild map for NIS server", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_NIS/set a correct NISdomain", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_NIS/update the client configuration file", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_DNS", undef, undef, undef, '<Branch>', ],
             [ "/_DNS/adjust resolv.conf", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DNS/generate a rndc.key", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DNS/adjust hosts with ip and hostname", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_DNS/set a DNS master server", undef, \&callback, 1, '<StockItem>', 'gtk-execute' ],
	     );

my @items2 = (
             [ "/No_de", undef, undef, undef, '<Branch>', ],
             [ "/No_de/Add a node", undef, \&ADD, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Install", undef, undef, undef, '<Branch>', ],
             [ "/_Install/Auto-Configure a remote installation server", undef, \&I, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Server", undef, undef, undef, '<Branch>', ],
             [ "/_Server/Auto-Configure a cluster server", undef, \&S, 1, '<StockItem>', 'gtk-execute' ],


             [ "/_DNS", undef, undef, undef, '<Branch>', ],
             [ "/_DNS/Auto-Configure a master Domain name server", undef, \&D, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_NIS", undef, undef, undef, '<Branch>', ],
             [ "/_NIS/Auto-Setup a Network Information Service", undef, \&N, 1, '<StockItem>', 'gtk-execute' ],

             [ "/D_HCPD", undef, undef, undef, '<Branch>', ],
             [ "/D_HCPD/Auto-Configure a Dynamic Host Configuration Protocol server", undef, \&H, 1, '<StockItem>', 'gtk-execute' ],
#             [ "/D_HCPD/Add a node in DHCPD configuration", undef, \&HN, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_PXE", undef, undef, undef, '<Branch>', ],
             [ "/_PXE/Auto-Configure a PXE server Pre-boot Execution Environment", undef, \&P, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Admin", undef, undef, undef, '<Branch>', ],
             [ "/_Admin/Auto-Configure all administration tools", undef, \&A, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Compute", undef, undef, undef, '<Branch>', ],
             [ "/_Compute/Auto-Configure all HPC tools", undef, \&C, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/Auto-Activate compute interface (available with 2 interfaces on nodes)", undef, \&AC, 1, '<StockItem>', 'gtk-execute' ],
             [ "/_Compute/Add the server as compute node (n253)", undef, \&ASC, 1, '<StockItem>', 'gtk-execute' ],

             [ "/P_BS", undef, undef, undef, '<Branch>', ],
             [ "/P_BS/Auto-Configure a PBS server (queue job)", undef, \&B, 1, '<StockItem>', 'gtk-execute' ],

             [ "/_Maui", undef, undef, undef, '<Branch>', ],
             [ "/_Maui/Auto-Configure a MAUI server (scheduler server)", undef, \&M, 1, '<StockItem>', 'gtk-execute' ],

             [ "/P_ostfix", undef, undef, undef, '<Branch>', ],
             [ "/P_ostfix/Auto-Configure a Mail server", undef, \&O, 1, '<StockItem>', 'gtk-execute' ],

             [ "/Userdrake", undef, undef, undef, '<Branch>', ],
             [ "/Userdrake/Launch userdrake", undef, \&userdrake, 1, '<StockItem>', 'gtk-execute' ],
	     );

sub get_items {
    my ($e) = @_;
    if ($e eq "expert") {
	@items;
    } else {
	@items2;
    }
}

sub callback() {
    print "test ok\n";
}

sub userdrake() { open(FD, "userdrake|") }

# use shortcut to name fonction
sub ADD() {
    my $t = "Add a node";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_add_nodes_to_dhcp.pl -n1; setup_add_node.pl; setup_server_cluster.pl need_ar", $t);
}

sub I() {
    my $t = "Configure a remote installation server";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_install_cluster.pl doall", $t);
}

sub S() {
    my $t = "Configure a cluster server";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_server_cluster.pl doall", $t);
}

sub N() {
    my $t = "Setup a Network Information Service";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
  run_command_and_log("setup_nis.pl set_server", $t);
}

sub D() {
    my $t = "Configure a master Domain name server";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
  run_command_and_log("setup_dns.pl set_server", $t);
}

sub H() {
    my $t = "Configure a Dynamic Host Configuration Protocol server";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_dhcpdconf_server.pl doall", $t);
}

sub HN() {
    my $t = "add a node in DHCPD configuration";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_add_nodes_to_dhcp.pl -n 1", $t);
}

sub AC() {
    my $t = "Activate compute interface on all nodes";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_add_nodes_to_dhcp.pl -c", $t);
}

sub ASC() {
    my $t = "Activate the server as compute node (n253)";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_server_cluster.pl add_srv", $t);
}

sub P() {
    my $t = "Configure a PXE server (Pre boot execution)";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_pxe_server.pl build; setup_pxe_server.pl setup linux", $t);
}
sub A() {
    my $t = "Configure all administration tools";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_admin.pl doall", $t);
}
sub C() {
    my $t = "Configure all HPC tools";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_compute.pl doall", $t);
}

sub B() {
    my $t = "Configure a PBS server (queue job)";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_pbs.pl doall", $t);
}
sub M() {
    my $t = "Configure a MAUI server (scheduler server)";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
    run_command_and_log("setup_maui.pl doall", $t);
}
sub O() {
    my $t = "Configure a Mail server";
    $::in->ask_okcancel($t, "Are you sure ?") or return;
  run_command_and_log("setup_postfix.pl set", $t);
}

1;
