package drakcluster::server_conf_ui;

use strict;

use cluster_fonction_common;
use cluster_serverconf;
use cluster_commonconf;
use dns_cluster;
use drakcluster::server_conf;
use common;
use ugtk2 qw(:wrappers :create);

sub default_conf() {
    {
	DOMAINNAME => chomp_(`dnsdomainname`),
        NISDOMAINNAME => chomp_(`dnsdomainname`),
	NTPSERVER => interface_to_ip('eth0'),
	CDROM => '/mnt/cdrom',
    };
}

################################################################################
sub create {
    my ($conf) = @_;

    my @network_interfaces = qw(eth0 eth1 eth2);

#    $conf->{DNSKEY} ||= dns_cluster::generate_rndc();

    my $apply;
    my @fields; @fields = map_index { 
	my ($e, $i) = ($_, $::i);

	my ($real_w, $w);
	if ($e->{list}) {
	    $w = Gtk2::Combo->new;
	    $w->set_use_arrows_always(1);
	    $w->entry->set_editable(!$e->{not_edit});
	    $w->disable_activate;
	    $w->set_popdown_strings(@{$e->{list}});
	    ($real_w, $w) = ($w, $w->entry);
	} else {
	    $real_w = $w = Gtk2::Entry->new;
	}

	$w->set_text(${$e->{val}});
	$w->signal_connect(changed => sub { 
	    $apply->set_sensitive(1);
	    ${$e->{val}} = $w->get_text;
	});


	# "Return" goes to next entry
        $w->signal_connect(key_press_event => sub {
			     my (undef, $event) = @_;
			     if ($event->keyval == $Gtk2::Gdk::Keysyms{Return}) {
			       ($i < $#fields ? $fields[$i + 1]{w} : $apply)->grab_focus;
			       1;
			     } else {
			       0;
			     }
			   });
	
	$e->{label_w} = Gtk2::Label->new;
	my $set_label_w = sub { 
	    my $s = $e->{check} && $e->{check}->(${$e->{val}}, $e->{label}, 'check') ? qq(<span foreground="red">$e->{label}</span>) : $e->{label};
	    $e->{label_w}->set_markup($s);
	};
	$set_label_w->();
	$w->signal_connect(focus_out_event => sub { $set_label_w->(); 0 });

	put_in_hash($e, { w => $w, real_w => $real_w });
        $e;
    } drakcluster::server_conf::fields($conf, \@network_interfaces, default_conf());

    $apply = Gtk2::Button->new(N("Apply"));
    $apply->signal_connect(clicked => sub {
	every {
	    if (!drakcluster::server_conf::check_field($::in, $_)) {
		$_->{w}->grab_focus;
		0;
	    } else { 1 }
	} @fields or return;

	$apply->set_sensitive(0);
	drakcluster::server_conf::done($conf, \@network_interfaces);
    });
    
    gtkpack_(Gtk2::VBox->new,
	     1, create_packtable({}, map { [ $_->{label_w}, $_->{real_w} ] } @fields),
	     0, $apply);
}

1;
